// Copyright 2024 The Mellium Contributors.
// Use of this source code is governed by the BSD 2-clause
// license that can be found in the LICENSE file.

//go:build integration
// +build integration

package x3dh_test

import (
	"bytes"
	"crypto/ecdh"
	"crypto/ed25519"
	"encoding/hex"
	"encoding/json"
	"fmt"
	"io"
	"testing"

	"mellium.im/crypto/internal/python"
	"mellium.im/crypto/x3dh"
)

type finalMsg struct {
	SessionKey string `json:"shared_secret"`
	AssocData  string `json:"associated_data"`
}

type bundle struct {
	PubID   ed25519.PublicKey
	PrivID  ed25519.PrivateKey
	PubSPK  *ecdh.PublicKey
	PrivSPK *ecdh.PrivateKey
	Sig     []byte
	PreKeys [][]byte
}

func decodePythonString(s string) ([]byte, error) {
	buf := bytes.NewBuffer(nil)
	for _, c := range s {
		err := buf.WriteByte(byte(c))
		if err != nil {
			return nil, err
		}
	}
	return buf.Bytes(), nil
}

func (b *bundle) UnmarshalJSON(p []byte) error {
	s := struct {
		IdentityKey struct {
			Secret string `json:"secret"`
		} `json:"identity_key"`
		SPK struct {
			Priv string `json:"priv"`
			Sig  string `json:"sig"`
		} `json:"signed_pre_key"`
	}{}
	err := json.Unmarshal(p, &s)
	if err != nil {
		return err
	}

	unquoted, err := decodePythonString(s.IdentityKey.Secret)
	if err != nil {
		return fmt.Errorf("error decoding ID secret: %v", err)
	}
	b.PrivID = ed25519.NewKeyFromSeed([]byte(unquoted))
	b.PubID = b.PrivID.Public().(ed25519.PublicKey)

	curve := ecdh.X25519()
	unquoted, err = decodePythonString(s.SPK.Priv)
	if err != nil {
		return fmt.Errorf("error decoding SPK priv part: %v", err)
	}
	b.PrivSPK, err = curve.NewPrivateKey([]byte(unquoted))
	if err != nil {
		return err
	}
	b.PubSPK = b.PrivSPK.Public().(*ecdh.PublicKey)
	unquoted, err = decodePythonString(s.SPK.Sig)
	if err != nil {
		return fmt.Errorf("error decoding SPK sig: %v", err)
	}
	b.Sig = []byte(unquoted)
	return nil
}

func TestIntegrationNegotiation(t *testing.T) {
	// First generate an ID key and Shared Pre Key (SPK) in Go for use in the
	// exchange tests.
	_, idPriv, err := ed25519.GenerateKey(nil)
	if err != nil {
		t.Fatalf("error generating ed25519 key: %v", err)
	}
	idPub := idPriv.Public().(ed25519.PublicKey)
	spkPriv, spkSig, err := x3dh.NewSignedPreKey(idPriv)
	if err != nil {
		t.Fatalf("error generating SPK: %v", err)
	}
	spkPub := spkPriv.PublicKey()

	// Generate and receive the init message in both Python and Go and check that
	// the shared secret matches in all cases.
	// In a real key exchange, you wouldn't send the private keys back and forth
	// alongside all the other information, of course, but for the sake of testing
	// we want to try this both ways using the same keys in both Python and Go.
	python.Run(t, "init", "import x3dh_test; x3dh_test.test_negotiation_recv()", func(t *testing.T, stdin io.Writer, stdout io.Reader) {
		// First, receive the bundle of keys generated by Python.
		b := &bundle{}
		d := json.NewDecoder(stdout)
		err = d.Decode(b)
		if err != nil {
			t.Fatalf("error unmarshaling JSON: %v", err)
		}

		sessKey, _, eKey, err := x3dh.NewInitMessage(idPriv, b.PubID, nil, b.PubSPK, b.Sig)
		if err != nil {
			t.Fatalf("error generating init message: %v", err)
		}

		e := json.NewEncoder(stdin)
		err = e.Encode(struct {
			IdentityKeyPub string `json:"identity_key_pub"`
			EKey           string `json:"ekey"`
		}{
			IdentityKeyPub: hex.EncodeToString(idPub),
			EKey:           hex.EncodeToString(eKey.Bytes()),
		})
		if err != nil {
			t.Fatalf("error encoding message values: %v", err)
		}

		var final finalMsg
		err = d.Decode(&final)
		if err != nil && err != io.EOF {
			t.Fatalf("error reading shared secret from buffer: %v", err)
		}
		sessKeyRecv, _, err := x3dh.RecvInitMessage(b.PrivID, nil, b.PrivSPK, idPub, eKey)
		if err != nil {
			t.Fatalf("error receiving initial message: %v", err)
		}
		if s := hex.EncodeToString(sessKey); s != final.SessionKey || !bytes.Equal(sessKey, sessKeyRecv) {
			t.Fatalf(`Final session keys did not match:
- Go init: %0x
- Go recv: %0x
- Py recv: %s`, sessKey, sessKeyRecv, final.SessionKey)
		}
	})

	python.Run(t, "recv", "import x3dh_test; x3dh_test.test_negotiation_init()", func(t *testing.T, stdin io.Writer, stdout io.Reader) {
		// First "publish" the bundle by sending it over to Python.
		e := json.NewEncoder(stdin)
		err = e.Encode(struct {
			IdentityKeyPub string `json:"identity_key_pub"`
			SPKPub         string `json:"spk_pub"`
			SPKSig         string `json:"spk_sig"`
		}{
			IdentityKeyPub: hex.EncodeToString(idPub),
			SPKPub:         hex.EncodeToString(spkPub.Bytes()),
			SPKSig:         hex.EncodeToString(spkSig),
		})

		// Now receive the initial key exchange message:
		d := json.NewDecoder(stdout)
		final := struct {
			finalMsg

			IDKey string `json:"idkey"`
			EKey  string `json:"ek"`
			SPK   string `json:"spk"`
		}{}
		err = d.Decode(&final)
		if err != nil {
			t.Fatalf("error unmarshaling JSON: %v", err)
		}

		// Convert all the keys to a usable format
		idKeyB, err := hex.DecodeString(final.IDKey)
		if err != nil {
			t.Fatalf("error decoding idkey: %v", err)
		}
		peerID := ed25519.PublicKey(idKeyB)

		eKeyB, err := hex.DecodeString(final.EKey)
		if err != nil {
			t.Fatalf("error decoding ephemeral key: %v", err)
		}
		ekPub, err := ecdh.X25519().NewPublicKey(eKeyB)
		if err != nil {
			t.Fatalf("error creating ephemeral key: %v", err)
		}

		// Finally, perform the other side of the handshake to get the shared secret
		// and compare it with the secret we already shared.
		sessKey, _, err := x3dh.RecvInitMessage(idPriv, nil, spkPriv, peerID, ekPub)
		if err != nil {
			t.Fatalf("error receiving initial message: %v", err)
		}
		if s := hex.EncodeToString(sessKey); s != final.SessionKey {
			t.Fatalf(`Final session keys did not match:
- Py init: %s
- Go recv: %0x`, final.SessionKey, sessKey)
		}
	})
}
